local matRefraction	= Material( "refract_ring" )


local tMats = {}
tMats.Glow1 = Material("sprites/light_glow02")
tMats.Glow2 = Material("sprites/flare1")

for _,mat in pairs(tMats) do

	mat:SetMaterialInt("$spriterendermode",9)
	mat:SetMaterialInt("$ignorez",1)
	mat:SetMaterialInt("$illumfactor",8)
	
end

local SmokeParticleUpdate = function(particle)

	if particle:GetStartAlpha() == 0 and particle:GetLifeTime() >= 0.5*particle:GetDieTime() then
		particle:SetStartAlpha(particle:GetEndAlpha())
		particle:SetEndAlpha(0)
		particle:SetNextThink(-1)
	else
		particle:SetNextThink(CurTime() + 0.1)
	end

	return particle

end


function EFFECT:Init(data)

	self.Scale = data:GetScale()
	self.ScaleSlow = math.sqrt(self.Scale)
	self.ScaleSlowest = math.sqrt(self.ScaleSlow)
	self.Normal = data:GetNormal()
	self.RightAngle = self.Normal:Angle():Right():Angle()
	self.Position = data:GetOrigin() - 12*self.Normal
	self.Position2 = self.Position + self.Scale*64*self.Normal

	local CurrentTime = CurTime()
	self.Duration = 0.5*self.Scale 
	self.KillTime = CurrentTime + self.Duration
	self.GlowAlpha = 200
	self.GlowSize = 100*self.Scale
	self.FlashAlpha = 100
	self.FlashSize = 0

      self.Refract = 0
	self.Size = 5
	if render.GetDXLevel() <= 81 then
		matRefraction = Material( "effects/strider_pinch_dudv" )
	end


	local emitter = ParticleEmitter(self.Position)


	

	--fire burst2
		for i=1,math.ceil(self.Scale*25) do
			
			local vecang = (self.Normal + VectorRand()*math.Rand(0.5,1.5)):GetNormalized()
			local velocity = math.Rand(750,750)*vecang*self.Scale
			local particle = emitter:Add("effects/fire_cloud"..math.random(1,2),  self.Position - vecang*32*self.Scale)
			particle:SetVelocity(velocity)
			particle:SetDieTime(math.Rand(2,2))
			particle:SetStartAlpha(math.Rand(230,250))
			particle:SetStartSize(math.Rand(20,20)*self.ScaleSlow)
			particle:SetEndSize(math.Rand(20,20)*self.ScaleSlow)
			particle:SetStartLength(math.Rand(500,500)*self.ScaleSlow)
			particle:SetEndLength(math.Rand(500,500)*self.ScaleSlow)
			particle:SetColor(0,0,255)

		end
			--Shockwave
		for i=1,math.ceil(self.Scale*100) do

			local vecang = self.RightAngle
                  local startalpha = math.Rand( 0, 0 )
			vecang:RotateAroundAxis(self.Normal,math.Rand(9,9))
			vecang = vecang:Forward() + VectorRand()*0.1
			local velocity = math.Rand(10000,10000)*vecang
			local particle = emitter:Add( "particles/Smoke1", self.Position - vecang*64*self.Scale - self.Normal*16)
			local dietime = math.Rand(3.7,3.9)*self.Scale
			particle:SetVelocity(velocity*self.Scale)
			particle:SetGravity(Vector(0,0,math.Rand(0,0)))
			particle:SetAirResistance(5) 
                  particle:SetStartAlpha(50)
                  particle:SetEndAlpha( 0 )
			particle:SetDieTime(dietime)
			particle:SetStartSize(math.Rand(200,200)*self.ScaleSlow)
			particle:SetEndSize(math.Rand(200,200)*self.ScaleSlow)
			particle:SetRoll(math.Rand(10,10))
			particle:SetRollDelta(0.6*math.random(-1,1))
			particle:SetColor(200,200,200)
                  
			
		end

	--fire burst1
		for i=1,math.ceil(self.Scale*25) do
			
			local vecang = (self.Normal + VectorRand()*math.Rand(0.5,1.5)):GetNormalized()
			local velocity = math.Rand(750,750)*vecang*self.Scale
			local particle = emitter:Add("effects/fire_cloud"..math.random(1,2),  self.Position - vecang*32*self.Scale)
			particle:SetVelocity(velocity)
			particle:SetDieTime(math.Rand(2,2))
			particle:SetStartAlpha(math.Rand(230,250))
			particle:SetStartSize(math.Rand(20,20)*self.ScaleSlow)
			particle:SetEndSize(math.Rand(20,20)*self.ScaleSlow)
			particle:SetStartLength(math.Rand(500,500)*self.ScaleSlow)
			particle:SetEndLength(math.Rand(500,500)*self.ScaleSlow)
			particle:SetColor(255,255,255)

		end


--Mushroom Cloud
		for i=1,math.ceil(self.Scale*15) do

			local vecang = self.RightAngle
			vecang:RotateAroundAxis(self.Normal,math.Rand(0,360))
			vecang = vecang:Forward() + VectorRand()*0.1
			local velocity = math.Rand(600,600)*vecang
			local particle = emitter:Add("particles/Fire7", self.Position - vecang*32*self.Scale - self.Normal*16)
			local dietime = math.Rand(20.5,20.9)*self.Scale
			particle:SetVelocity(velocity*self.Scale)
			particle:SetGravity(Vector(0,0,math.Rand(50,50)))
			particle:SetAirResistance(50)
			particle:SetDieTime(dietime)
			particle:SetStartAlpha(100)
			particle:SetEndAlpha(0)
			particle:SetStartSize(math.Rand(200,200)*self.ScaleSlow)
			particle:SetEndSize(math.Rand(300,300)*self.ScaleSlow)
			particle:SetRoll(math.Rand(150,180))
			particle:SetRollDelta(0.6*math.random(-1,1))
			particle:SetColor(200,200,200)
			
end
--Mushroom Cloud
		for i=1,math.ceil(self.Scale*20) do

			local vecang = self.RightAngle
			vecang:RotateAroundAxis(self.Normal,math.Rand(0,360))
			vecang = vecang:Forward() + VectorRand()*0.1
			local velocity = math.Rand(100,600)*vecang
			local particle = emitter:Add("particles/Dirt",   self.Position - vecang*32*self.Scale - self.Normal*16)
			local dietime = math.Rand(20.5,20.9)*self.Scale
			particle:SetVelocity(velocity*self.Scale)
			particle:SetGravity(Vector(0,0,math.Rand(0,50)))
			particle:SetAirResistance(50)
			particle:SetDieTime(dietime)
			particle:SetStartAlpha(100)
			particle:SetEndAlpha(0)
			particle:SetStartSize(math.Rand(300,300)*self.ScaleSlow)
			particle:SetEndSize(math.Rand(400,400)*self.ScaleSlow)
			particle:SetRoll(math.Rand(150,180))
			particle:SetRollDelta(0.6*math.random(-1,1))
			particle:SetColor(200,200,200)
			
end
--Mushroom CloudSmall
		for i=1,math.ceil(self.Scale*480) do

			local vecang = self.RightAngle
			vecang:RotateAroundAxis(self.Normal,math.Rand(0,360))
			vecang = vecang:Forward() + VectorRand()*0.1
			local velocity = math.Rand(200,900)*vecang
			local particle = emitter:Add("particles/Dirt",   self.Position - vecang*32*self.Scale - self.Normal*16)
			local dietime = math.Rand(20.5,20.9)*self.Scale
			particle:SetVelocity(velocity*self.Scale)
			particle:SetGravity(Vector(0,0,math.Rand(0,0)))
			particle:SetAirResistance(50)
			particle:SetDieTime(dietime)
			particle:SetStartAlpha(100)
			particle:SetEndAlpha(0)
			particle:SetStartSize(math.Rand(25,100)*self.ScaleSlow)
			particle:SetEndSize(math.Rand(25,100)*self.ScaleSlow)
			particle:SetRoll(math.Rand(150,180))
			particle:SetRollDelta(0.6*math.random(-1,1))
			particle:SetColor(200,200,200)
			
end
--Mushroom CloudFire
		for i=1,math.ceil(self.Scale*30) do

			local vecang = self.RightAngle
			vecang:RotateAroundAxis(self.Normal,math.Rand(0,360))
			vecang = vecang:Forward() + VectorRand()*0.1
			local velocity = math.Rand(100,1000)*vecang
			local particle = emitter:Add("particles/FireExplosion",  self.Position - vecang*32*self.Scale - self.Normal*16)
			local dietime = math.Rand(0.3,0.3)*self.Scale
			particle:SetVelocity(velocity*self.Scale)
			particle:SetGravity(Vector(0,0,math.Rand(0,0)))
			particle:SetAirResistance(50)
			particle:SetDieTime(dietime)
			particle:SetStartAlpha(100)
			particle:SetEndAlpha(0)
			particle:SetStartSize(math.Rand(900,900)*self.ScaleSlow)
			particle:SetEndSize(math.Rand(900,900)*self.ScaleSlow)
			particle:SetRoll(math.Rand(150,180))
			particle:SetRollDelta(0.6*math.random(-1,1))
			particle:SetColor(255,255,255)
			
end

	
		
		--shock wave
			for i=1,math.ceil(self.Scale*20) do

				local vecang = Vector(math.Rand(-1,1),math.Rand(-1,1),0):GetNormalized()
				local velocity = math.Rand(1000,1000)*vecang
				local particle = emitter:Add("sprites/heatwave", self.Position - vecang*64*self.Scale - Vector(0,0,80*self.ScaleSlowest))
				local dietime = 0.08*self.Scale
				particle:SetVelocity(velocity)
				particle:SetDieTime(dietime)
				particle:SetLifeTime(0)
				particle:SetStartAlpha(60)
				particle:SetEndAlpha(0)
				particle:SetStartSize(500)
				particle:SetEndSize(500)
				particle:SetColor(255,255,255)
				
			end
	
		--dirt
		for i=1,math.ceil(math.Rand(20,40)*self.ScaleSlow) do
			
			local vecang = (self.Normal + VectorRand()*math.Rand(0,3)):GetNormalized()
			local particle = emitter:Add("effects/fleck_cement"..math.random(1,2), self.Position + vecang*64*self.Scale)
			local size = math.Rand(50,100)
			particle:SetVelocity(vecang*math.Rand(1200,2200)*self.ScaleSlow)
			particle:SetGravity(Vector(0,0,-600))
			particle:SetAirResistance(1)
			particle:SetDieTime(math.Rand(2.8,3.5)*self.ScaleSlow)
			particle:SetStartAlpha(math.Rand(140,170))
			particle:SetEndAlpha(0)
			particle:SetStartSize(size)
			particle:SetEndSize(size)
			particle:SetRoll(math.Rand(400,500))
			particle:SetRollDelta(math.Rand(-24,24))
			particle:SetCollide(true)
			particle:SetBounce(0.9)
			particle:SetColor(173,160,143)

		end
	emitter:Finish()
	
		surface.PlaySound("ambient/explosions/explode_8.wav")
		self.Entity:EmitSound("ambient/explosions/explode_4.wav")

end


--THINK
-- Returning false makes the entity die
function EFFECT:Think()
	local TimeLeft = self.KillTime - CurTime()
	local TimeScale = TimeLeft/self.Duration
	local FTime = FrameTime()
	if TimeLeft > 0 then 

		self.FlashAlpha = self.FlashAlpha - 200*FTime
		self.FlashSize = self.FlashSize + 60000*FTime
		
		self.GlowAlpha = 200*TimeScale
		self.GlowSize = TimeLeft*self.Scale

           self.Size = self.Size + 60000*FTime
	     self.Refract = self.Refract + 1.3*FTime

		return true
	else
		return false	
	end
end



-- Draw the effect
function EFFECT:Render()

--base glow
render.SetMaterial(tMats.Glow1)
render.DrawSprite(self.Position2,7000*self.GlowSize,5500*self.GlowSize,Color(255,240,220,self.GlowAlpha))

--blinding flash
	if self.FlashAlpha > 0 then
		render.SetMaterial(tMats.Glow2)
		render.DrawSprite(self.Position2,self.FlashSize,self.FlashSize,Color(255,245,215,self.FlashAlpha))
	end


	--shockwave

		local Distance = EyePos():Distance( self.Entity:GetPos() )
		local Pos = self.Entity:GetPos() + (EyePos() - self.Entity:GetPos()):GetNormal() * Distance * (self.Refract^(0.3)) * 0.8

		matRefraction:SetMaterialFloat( "$refractamount", math.sin( self.Refract * math.pi ) * 1 )
		render.SetMaterial( matRefraction )
		render.UpdateRefractTexture()
		render.DrawSprite( Pos, self.Size, self.Size )

	end



