local matRefraction	= Material( "refract_ring" )

local tMats = {}
tMats.Glow1 = Material("sprites/light_glow02")
tMats.Glow2 = Material("sprites/flare1")

for _,mat in pairs(tMats) do

	mat:SetMaterialInt("$spriterendermode",9)
	mat:SetMaterialInt("$ignorez",1)
	mat:SetMaterialInt("$illumfactor",8)
	
end

local SmokeParticleUpdate = function(particle)

	if particle:GetStartAlpha() == 0 and particle:GetLifeTime() >= 0.5*particle:GetDieTime() then
		particle:SetStartAlpha(particle:GetEndAlpha())
		particle:SetEndAlpha(0)
		particle:SetNextThink(-1)
	else
		particle:SetNextThink(CurTime() + 0.1)
	end

	return particle

end


function EFFECT:Init(data)

	self.Scale = data:GetScale()
	self.ScaleSlow = math.sqrt(self.Scale)
	self.ScaleSlowest = math.sqrt(self.ScaleSlow)
	self.Normal = data:GetNormal()
	self.RightAngle = self.Normal:Angle():Right():Angle()
	self.Position = data:GetOrigin() - 12*self.Normal
	self.Position2 = self.Position + self.Scale*64*self.Normal

	local CurrentTime = CurTime()
	self.Duration = 0.5*self.Scale 
	self.KillTime = CurrentTime + self.Duration
	self.GlowAlpha = 200
	self.GlowSize = 100*self.Scale
	self.FlashAlpha = 100
	self.FlashSize = 0
 
      self.Refract = 0
	self.Size = 5
	if render.GetDXLevel() <= 81 then
		matRefraction = Material( "effects/strider_pinch_dudv" )
	end


	local emitter = ParticleEmitter(self.Position)


		

		--Mushroom Cloud
		for i=1,math.ceil(self.Scale*30) do

			local vecang = self.RightAngle
			vecang:RotateAroundAxis(self.Normal,math.Rand(0,360))
			vecang = vecang:Forward() + VectorRand()*0.1
			local velocity = math.Rand(100,800)*vecang
			local particle = emitter:Add("particles/Smoke6",  self.Position - vecang*32*self.Scale - self.Normal*16)
			local dietime = math.Rand(3.5,3.9)*self.Scale
			particle:SetVelocity(velocity*self.Scale)
			particle:SetGravity(Vector(0,0,math.Rand(0,0)))
			particle:SetAirResistance(50)
			particle:SetDieTime(dietime)
			particle:SetLifeTime(math.Rand(-0.12,-0.08))
			particle:SetStartAlpha(150)
			particle:SetEndAlpha(0)
			particle:SetStartSize(math.Rand(100,100)*self.ScaleSlow)
			particle:SetEndSize(math.Rand(300,300)*self.ScaleSlow)
			particle:SetRoll(math.Rand(150,180))
			particle:SetRollDelta(0.6*math.random(-1,1))
			particle:SetColor(255,255,255)
			
		end

			--fire ball
		for i=1,math.ceil(self.Scale*24) do
			
			local vecang = (self.Normal + VectorRand()*math.Rand(1,1)):GetNormalized()
			local velocity = math.Rand(700,1100)*vecang*self.Scale
			local particle = emitter:Add("effects/fire_cloud"..math.random(1,2), self.Position + vecang*math.Rand(0,70)*self.Scale)
			particle:SetVelocity(velocity)
                  particle:SetStartAlpha(50)
			particle:SetGravity(Vector(0,0,math.Rand(750,750)))
			particle:SetAirResistance(200)
			particle:SetDieTime(math.Rand(3.5,3.9)*self.Scale)
			particle:SetStartAlpha(math.Rand(230,250))
			particle:SetStartSize(math.Rand(110,140)*self.ScaleSlow)
			particle:SetEndSize(math.Rand(900,900)*self.ScaleSlow)
			particle:SetRoll(math.Rand(150,180))
			particle:SetRollDelta(0.6*math.random(-1,1))
			particle:SetColor(255,255,255)

		end
	--embers
		for i=1,math.ceil(self.Scale*20) do
			
			local vecang = (self.Normal + VectorRand()*math.Rand(0.2,1.2)):GetNormalized()
			local particle = emitter:Add("effects/fire_embers"..math.random(1,3), self.Position + vecang*math.random(160,480)*self.ScaleSlow)
			particle:SetVelocity(VectorRand()*math.Rand(32,96))
			particle:SetAirResistance(1)
			particle:SetDieTime(math.Rand(2,2.4)*self.ScaleSlow)
			particle:SetStartAlpha(math.Rand(250,255))
			particle:SetStartSize(math.Rand(16,21)*self.ScaleSlow)
			particle:SetEndSize(math.Rand(16,21)*self.ScaleSlow)
			particle:SetColor(255,255,255)

		end
			--fire burst
		for i=1,math.ceil(self.Scale*16) do
			
			local vecang = (self.Normal + VectorRand()*math.Rand(0.5,1.5)):GetNormalized()
			local velocity = math.Rand(2000,2000)*vecang*self.Scale
			local particle = emitter:Add("effects/fire_embers"..math.random(1,3), self.Position - vecang*32*self.Scale)
			particle:SetVelocity(velocity)
			particle:SetDieTime(math.Rand(6,6))
			particle:SetStartAlpha(math.Rand(230,250))
			particle:SetStartSize(math.Rand(30,40)*self.ScaleSlow)
			particle:SetEndSize(math.Rand(40,50)*self.ScaleSlow)
			particle:SetStartLength(math.Rand(50,50)*self.ScaleSlow)
			particle:SetEndLength(math.Rand(500,500)*self.ScaleSlow)
			particle:SetColor(255,255,255)		
                  

		end
		
	--dirt
		for i=1,math.ceil(math.Rand(60,80)*self.ScaleSlow) do
			
			local vecang = (self.Normal + VectorRand()*math.Rand(0,3)):GetNormalized()
			local particle = emitter:Add("particles/Smoke6",  self.Position + vecang*64*self.Scale)
			local size = math.Rand(5,25)*self.Scale
			particle:SetVelocity(vecang*math.Rand(1100,2200)*self.ScaleSlow)
			particle:SetGravity(Vector(0,0,-600))
			particle:SetAirResistance(1)
			particle:SetDieTime(math.Rand(0.8,0.5)*self.ScaleSlow)
			particle:SetStartAlpha(math.Rand(140,170))
			particle:SetEndAlpha(0)
			particle:SetStartSize(size)
			particle:SetEndSize(size)
			particle:SetRoll(math.Rand(400,500))
			particle:SetRollDelta(math.Rand(-24,24))
			particle:SetCollide(true)
			particle:SetBounce(0.9)
			particle:SetColor(173,160,143)

		end
		--pillar of dust
		for i=1,math.ceil(self.Scale*12) do

			local vecang = (self.Normal + VectorRand()*math.Rand(0,0.5)):GetNormalized()
			local velocity = math.Rand(-300,500)*vecang*self.Scale
			local particle = emitter:Add("particles/Smoke6",  self.Position + vecang*math.Rand(-50,75)*self.Scale)
			local dietime = math.Rand(3.5,3.9)*self.Scale
			particle:SetVelocity(velocity)
			particle:SetGravity(Vector(0,0,math.Rand(50,250)))
			particle:SetAirResistance(65)
			particle:SetDieTime(dietime)
			particle:SetLifeTime(math.Rand(-0.12,-0.08))
			particle:SetStartAlpha(150)
			particle:SetEndAlpha(0)
			particle:SetThinkFunction(SmokeParticleUpdate)
			particle:SetNextThink(CurrentTime + 0.5*dietime)
			particle:SetStartSize(math.Rand(100,100)*self.ScaleSlow)
			particle:SetEndSize(math.Rand(300,300)*self.ScaleSlow)
			particle:SetRoll(math.Rand(150,170))
			particle:SetRollDelta(0.7*math.random(-1,1))
			particle:SetColor(250,250,250)
			
		end
		
		--shock wave
			for i=1,math.ceil(self.Scale*55) do

				local vecang = Vector(math.Rand(-1,1),math.Rand(-1,1),0):GetNormalized()
				local velocity = math.Rand(8900,9100)*vecang
				local particle = emitter:Add("sprites/heatwave", self.Position - vecang*64*self.Scale - Vector(0,0,80*self.ScaleSlowest))
				local dietime = 0.08*self.Scale
				particle:SetVelocity(velocity)
				particle:SetDieTime(dietime)
				particle:SetLifeTime(0)
				particle:SetStartAlpha(60)
				particle:SetEndAlpha(0)
				particle:SetStartSize(160*self.ScaleSlowest)
				particle:SetEndSize(200*self.ScaleSlowest)
				particle:SetColor(255,255,255)
				
	
		
		end

	emitter:Finish()
	
	if self.Scale > 4 then
		surface.PlaySound("ambient/explosions/explode_8.wav")
		self.Entity:EmitSound("ambient/explosions/explode_4.wav")

	elseif self.Scale > 11 then
		surface.PlaySound("ambient/explosions/explode_8.wav")
		self.Entity:EmitSound("ambient/explosions/explode_1.wav")
	
	elseif self.Scale > 23 then
		surface.PlaySound("ambient/explosions/exp1.wav")
		surface.PlaySound("ambient/explosions/explode_4.wav")
		
	elseif self.Scale > 35 then
		surface.PlaySound("ambient/explosions/exp2.wav")
		surface.PlaySound("ambient/explosions/explode_6.wav")
	
	else
		self.Entity:EmitSound("ambient/explosions/explode_4.wav")
	end
	
end


--THINK
-- Returning false makes the entity die
function EFFECT:Think()
	local TimeLeft = self.KillTime - CurTime()
	local TimeScale = TimeLeft/self.Duration
	local FTime = FrameTime()
	if TimeLeft > 0 then 

		self.FlashAlpha = self.FlashAlpha - 200*FTime
		self.FlashSize = self.FlashSize + 60000*FTime
		
		self.GlowAlpha = 200*TimeScale
		self.GlowSize = TimeLeft*self.Scale
   
           self.Size = self.Size + 60000*FTime
	     self.Refract = self.Refract + 1.3*FTime

		return true
	else
		return false	
	end
end


-- Draw the effect
function EFFECT:Render()

--base glow
render.SetMaterial(tMats.Glow1)
render.DrawSprite(self.Position2,7000*self.GlowSize,5500*self.GlowSize,Color(255,240,220,self.GlowAlpha))

--blinding flash
	if self.FlashAlpha > 0 then
		render.SetMaterial(tMats.Glow2)
		render.DrawSprite(self.Position2,self.FlashSize,self.FlashSize,Color(255,245,215,self.FlashAlpha))
	end

   if self.Scale > 25 then

		local Distance = EyePos():Distance( self.Entity:GetPos() )
		local Pos = self.Entity:GetPos() + (EyePos() - self.Entity:GetPos()):GetNormal() * Distance * (self.Refract^(0.3)) * 0.8

		matRefraction:SetMaterialFloat( "$refractamount", math.sin( self.Refract * math.pi ) * 1 )
		render.SetMaterial( matRefraction )
		render.UpdateRefractTexture()
		render.DrawSprite( Pos, self.Size, self.Size )

	end

end



