
local tMats = {}
tMats.Glow1 = Material("sprites/flare1")
tMats.Glow2 = Material("sprites/flare1")
tMats.Glow3 = Material("sprites/redglow2")
for _,mat in pairs(tMats) do

	mat:SetMaterialInt("$spriterendermode",9)
	mat:SetMaterialInt("$ignorez",1)
	mat:SetMaterialInt("$illumfactor",8)
	
end

local SmokeParticleUpdate = function(particle)

	if particle:GetStartAlpha() == 0 and particle:GetLifeTime() >= 0.5*particle:GetDieTime() then
		particle:SetStartAlpha(particle:GetEndAlpha())
		particle:SetEndAlpha(0)
		particle:SetNextThink(-1)
	else
		particle:SetNextThink(CurTime() + 0.1)
	end

	return particle

end



function EFFECT:Init(data)

	self.Scale = data:GetScale()
	self.ScaleSlow = math.sqrt(self.Scale)
	self.ScaleSlowest = math.sqrt(self.ScaleSlow)
	self.Normal = data:GetNormal()
	self.RightAngle = self.Normal:Angle():Right():Angle()
	self.Position = data:GetOrigin() - 12*self.Normal
	self.Position2 = self.Position + self.Scale*64*self.Normal

	local CurrentTime = CurTime()
      self.Duration = 3 
	self.KillTime = CurrentTime + self.Duration
	self.GlowAlpha = 200
	self.GlowSize = 500*self.Scale
	self.FlashAlpha = 200
	self.FlashSize = 500

	local emitter = ParticleEmitter(self.Position)

			self.smokeparticles = {}
                  
		
--Flare
		for i=1,math.ceil(self.Scale*1) do

			local startalpha = math.Rand( 0, 0 )
                  local vecang = (self.Normal + VectorRand()*math.Rand(1,1)):GetNormalized()
			local velocity = math.Rand(700,1100)*vecang*self.Scale
			local particle = emitter:Add( "sprites/flare1", self.Position + vecang*1,1*self.Scale)
			particle:SetVelocity(velocity)
                  particle:SetStartAlpha(100)            
			particle:SetGravity(Vector(0,0,math.Rand(1500,1500)))
			particle:SetAirResistance(200)
			particle:SetDieTime(math.Rand(5.7,5.9)*self.Scale)
			particle:SetStartSize(math.Rand(4000,4000)*self.ScaleSlow)
			particle:SetEndSize(math.Rand(4000,4000)*self.ScaleSlow)
			particle:SetRoll(math.Rand(0,0))
			particle:SetRollDelta(0.0*math.random(-0,0))
			particle:SetColor(200,200,200)
        

		end	
	
		--Mushroom Cloud
		for i=1,math.ceil(self.Scale*120) do

			local vecang = self.RightAngle
                  local startalpha = math.Rand( 0, 0 )
			vecang:RotateAroundAxis(self.Normal,math.Rand(0,360))
			vecang = vecang:Forward() + VectorRand()*0.1
			local velocity = math.Rand(100,4000)*vecang
			local particle = emitter:Add( "particles/flamelet"..math.random(1,5), self.Position - vecang*32*self.Scale - self.Normal*16)
			local dietime = math.Rand(5.5,5.9)*self.Scale
			particle:SetVelocity(velocity*self.Scale)
			particle:SetGravity(Vector(0,0,math.Rand(0,0)))
			particle:SetAirResistance(50)
			particle:SetDieTime(dietime)
			particle:SetStartAlpha(255)
			particle:SetEndAlpha( 0)
			particle:SetStartSize(math.Rand(300,300)*self.ScaleSlow)
			particle:SetEndSize(math.Rand(900,900)*self.ScaleSlow)
			particle:SetRoll(math.Rand(150,180))
			particle:SetRollDelta(0.6*math.random(-1,1))
			particle:SetColor(200,200,200)
			
		end


		--pillar of dust
		for i=1,math.ceil(self.Scale*100) do

             
                  local startalpha = math.Rand( 0, 0 )
			local vecang = (self.Normal + VectorRand()*math.Rand(0,1)):GetNormalized()
			local velocity = math.Rand(-100,200)*vecang*self.Scale
			local particle = emitter:Add( "particles/flamelet"..math.random(1,5), self.Position + vecang*math.Rand(-25,50)*self.Scale)
			local dietime = math.Rand(5.4,5.9)*self.Scale
			particle:SetVelocity(velocity)
			particle:SetGravity(Vector(0,0,math.Rand(10,80)))
			particle:SetAirResistance(6)
			particle:SetDieTime(dietime)
			particle:SetStartAlpha(255)
			particle:SetEndAlpha( 0 )
			particle:SetStartSize(math.Rand(500,500)*self.ScaleSlow)
			particle:SetEndSize(math.Rand(500,500)*self.ScaleSlow)
			particle:SetRoll(math.Rand(150,170))
			particle:SetRollDelta(0.7*math.random(-1,1))
			particle:SetColor(200,200,200)         
		end
--Mushroom Ring
		for i=1,math.ceil(self.Scale*30) do 

			local startalpha = math.Rand( 0, 0 )
			local vecang = Vector(math.Rand(-81,81),math.Rand(-81,81),math.Rand(1,1)):GetNormalized()
			local velocity = math.Rand(700,1100)*vecang*self.Scale
			local particle = emitter:Add( "particles/flamelet"..math.random(1,5), self.Position + vecang*2500,2500*self.Scale)
			particle:SetVelocity(velocity)
			particle:SetGravity(Vector(0,0,math.Rand(1000,1000)))
			particle:SetAirResistance(200)
			particle:SetDieTime(math.Rand(5.7,5.9)*self.Scale)
			particle:SetStartSize(math.Rand(1000,1000)*self.ScaleSlow)
			particle:SetEndSize(math.Rand(2000,2000)*self.ScaleSlow)
			particle:SetRoll(math.Rand(150,180))
			particle:SetRollDelta(0.6*math.random(-1,1))
			particle:SetColor(200,200,200)
           		particle:SetStartAlpha(255)
                  particle:SetEndAlpha( 0 )
		end	




--SmokeMushroomExplosion
		for i=1,math.ceil(self.Scale*30) do
                       
			local startalpha = math.Rand( 0, 0 )
                  local vecang = (self.Normal + VectorRand()*math.Rand(2,4)):GetNormalized()
			local velocity = math.Rand(700,1100)*vecang*self.Scale
			local particle = emitter:Add( "particles/flamelet"..math.random(1,5), self.Position + vecang*2000,3000*self.Scale)
			particle:SetVelocity(velocity)
                  particle:SetStartAlpha(255)
                  particle:SetEndAlpha( 0 )
			particle:SetGravity(Vector(0,0,math.Rand(1500,1500)))
			particle:SetAirResistance(200)
			particle:SetDieTime(math.Rand(5.4,5.9)*self.Scale)
			particle:SetStartSize(math.Rand(1000,1000)*self.ScaleSlow)
			particle:SetEndSize(math.Rand(2000,2000)*self.ScaleSlow)
			particle:SetRoll(math.Rand(150,180))
			particle:SetRollDelta(0.6*math.random(-1,1))
			particle:SetColor(200,200,200)

		end	

		--Mushroom Cloud
		for i=1,math.ceil(self.Scale*120) do

			local vecang = self.RightAngle
                  local startalpha = math.Rand( 0, 0 )
			vecang:RotateAroundAxis(self.Normal,math.Rand(0,360))
			vecang = vecang:Forward() + VectorRand()*0.1
			local velocity = math.Rand(100,4000)*vecang
			local particle = emitter:Add( "modulus/particles/Smoke6", self.Position - vecang*32*self.Scale - self.Normal*16)
			local dietime = math.Rand(30.5,30.9)*self.Scale
			particle:SetVelocity(velocity*self.Scale)
			particle:SetGravity(Vector(0,0,math.Rand(0,0)))
			particle:SetAirResistance(50)
			particle:SetDieTime(dietime)
			particle:SetStartAlpha(100)
			particle:SetEndAlpha( 0)
			particle:SetStartSize(math.Rand(300,1000)*self.ScaleSlow)
			particle:SetEndSize(math.Rand(900,1000)*self.ScaleSlow)
			particle:SetRoll(math.Rand(150,180))
			particle:SetRollDelta(0.6*math.random(-1,1))
			particle:SetColor(50,50,50)
			particle:SetLifeTime( math.Rand( -1.5, -1.5) )     
		end

		




		--pillar of dust
		for i=1,math.ceil(self.Scale*150) do

             
                  local startalpha = math.Rand( 0, 0 )
			local vecang = (self.Normal + VectorRand()*math.Rand(0,1)):GetNormalized()
			local velocity = math.Rand(-100,200)*vecang*self.Scale
			local particle = emitter:Add( "modulus/particles/Smoke6", self.Position + vecang*math.Rand(-25,50)*self.Scale)
			local dietime = math.Rand(30.4,30.9)*self.Scale
			particle:SetVelocity(velocity)
			particle:SetGravity(Vector(0,0,math.Rand(10,80)))
			particle:SetAirResistance(6)
			particle:SetDieTime(dietime)
			particle:SetStartAlpha(100)
			particle:SetEndAlpha( 0 )
			particle:SetStartSize(math.Rand(500,500)*self.ScaleSlow)
			particle:SetEndSize(math.Rand(500,500)*self.ScaleSlow)
			particle:SetRoll(math.Rand(150,170))
			particle:SetRollDelta(0.7*math.random(-1,1))
			particle:SetColor(50,50,50)  
                  particle:SetLifeTime( math.Rand( -1.5, -1.5) )     
                  
		end
--Mushroom Ring
		for i=1,math.ceil(self.Scale*50) do 

			local startalpha = math.Rand( 0, 0 )
			local vecang = Vector(math.Rand(-81,81),math.Rand(-81,81),math.Rand(1,1)):GetNormalized()
			local velocity = math.Rand(700,1100)*vecang*self.Scale
			local particle = emitter:Add( "modulus/particles/Smoke6", self.Position + vecang*2500,2500*self.Scale)
			particle:SetVelocity(velocity)
			particle:SetGravity(Vector(0,0,math.Rand(1000,1000)))
			particle:SetAirResistance(200)
			particle:SetDieTime(math.Rand(30.7,30.9)*self.Scale)
			particle:SetStartSize(math.Rand(1000,1000)*self.ScaleSlow)
			particle:SetEndSize(math.Rand(2000,2000)*self.ScaleSlow)
			particle:SetRoll(math.Rand(150,180))
			particle:SetRollDelta(0.6*math.random(-1,1))
			particle:SetColor(50,50,50)
			particle:SetStartAlpha(100)
			particle:SetEndAlpha( 0 )
                  particle:SetLifeTime( math.Rand( -1.5, -1.5) )
                  
			
end



--SmokeMushroomExplosion
		for i=1,math.ceil(self.Scale*75) do
                       
			local startalpha = math.Rand( 0, 0 )
                  local vecang = (self.Normal + VectorRand()*math.Rand(2,4)):GetNormalized()
			local velocity = math.Rand(700,1100)*vecang*self.Scale
			local particle = emitter:Add( "modulus/particles/Smoke6", self.Position + vecang*2000,3000*self.Scale)
			particle:SetVelocity(velocity)
			particle:SetStartAlpha(100)
			particle:SetEndAlpha( 0 )
			particle:SetGravity(Vector(0,0,math.Rand(1500,1500)))
			particle:SetAirResistance(200)
			particle:SetDieTime(math.Rand(30.4,30.9)*self.Scale)
			particle:SetStartSize(math.Rand(1000,1000)*self.ScaleSlow)
			particle:SetEndSize(math.Rand(2000,2000)*self.ScaleSlow)
			particle:SetRoll(math.Rand(150,180))
			particle:SetRollDelta(0.6*math.random(-1,1))
			particle:SetColor(50,50,50)
                  particle:SetLifeTime( math.Rand( -1.5, -1.5) )
                  
                  
		end	

	emitter:Finish()
	

		surface.PlaySound("ambient/explosions/explode_6.wav")
            surface.PlaySound("ambient/explosions/exp1.wav")
		surface.PlaySound("ambient/explosions/explode_4.wav")
	
	
end


--THINK
-- Returning false makes the entity die
function EFFECT:Think()
	local TimeLeft = self.KillTime - CurTime()
	local TimeScale = TimeLeft/self.Duration
	local FTime = FrameTime()
	if TimeLeft > 0 then 



		self.FlashAlpha = self.FlashAlpha - 100*FTime
		self.FlashSize = self.FlashSize + 12000000*FTime
		
		self.GlowAlpha = 200*TimeScale
		self.GlowSize = 500
	

		return true
	else
		for __,particle in pairs(self.smokeparticles) do
		particle:SetStartAlpha( 150 )
		particle:SetEndAlpha( 0 )
		end
		return false	
	end





end





-- Draw the effect
function EFFECT:Render()

--base glow
render.SetMaterial(tMats.Glow1)
render.DrawSprite(self.Position2,7000*self.GlowSize,5500*self.GlowSize,Color(255,240,220,self.GlowAlpha))

--blinding flash
	if self.FlashAlpha > 0 then
		render.SetMaterial(tMats.Glow2)
		render.DrawSprite(self.Position2,self.FlashSize,self.FlashSize,Color(255,245,215,self.FlashAlpha))
	end


end






