
local matRefraction	= Material( "refract_ring" )
matRefraction:SetMaterialInt("$nocull",1)

local tMats = {}
tMats.Glow1 = Material("sprites/flare1")
tMats.Glow2 = Material("sprites/flare1")
tMats.Glow3 = Material("sprites/redglow2")
for _,mat in pairs(tMats) do

	mat:SetMaterialInt("$spriterendermode",9)
	mat:SetMaterialInt("$ignorez",1)
	mat:SetMaterialInt("$illumfactor",8)
	
end

local SmokeParticleUpdate = function(particle)

	if particle:GetStartAlpha() == 0 and particle:GetLifeTime() >= 0.5*particle:GetDieTime() then
		particle:SetStartAlpha(particle:GetEndAlpha())
		particle:SetEndAlpha(0)
		particle:SetNextThink(-1)
	else
		particle:SetNextThink(CurTime() + 0.1)
	end

	return particle

end



function EFFECT:Init(data)

	self.Scale = data:GetScale()
	self.ScaleSlow = math.sqrt(self.Scale)
	self.ScaleSlowest = math.sqrt(self.ScaleSlow)
	self.Normal = data:GetNormal()
	self.RightAngle = self.Normal:Angle():Right():Angle()
	self.Position = data:GetOrigin() - 12*self.Normal
	self.Position2 = self.Position + self.Scale*64*self.Normal

	local CurrentTime = CurTime()
      self.Duration = 0
	self.KillTime = CurrentTime + self.Duration
	self.GlowAlpha = 200
	self.GlowSize = 500*self.Scale
	self.FlashAlpha = 200
	self.FlashSize = 500
      
      self.Refract = 0
	
	self.Size = 10


	local emitter = ParticleEmitter(self.Position)

			self.smokeparticles = {}






	--pillar of dust
		for i=1,math.ceil(self.Scale*60) do

			local vecang = (self.Normal + VectorRand()*math.Rand(0,0.5)):GetNormalized()
			local velocity = math.Rand(-700,700)*vecang*self.Scale
			local particle = emitter:Add("effects/splash1", self.Position + vecang*math.Rand(-50,90)*self.Scale)
			local dietime = math.Rand(25.5,25.9)*self.Scale
			particle:SetVelocity(velocity)       
			particle:SetGravity(Vector(0,0,math.Rand(0,1000)))
			particle:SetAirResistance(200)
			particle:SetDieTime(dietime)
			particle:SetStartAlpha(200)
			particle:SetEndAlpha(0)
			particle:SetStartSize(math.Rand(200,200)*self.ScaleSlow)
			particle:SetEndSize(math.Rand(1000,1000)*self.ScaleSlow)
			particle:SetRoll(math.Rand(150,170))
			particle:SetRollDelta(0.7*math.random(-1,1))
			particle:SetColor(255,255,255)
			
		end
		--Mushroom Cloud
		for i=1,math.ceil(self.Scale*60) do

			local vecang = self.RightAngle
			vecang:RotateAroundAxis(self.Normal,math.Rand(0,360))
			vecang = vecang:Forward() + VectorRand()*0.1
			local velocity = math.Rand(100,2000)*vecang
			local particle = emitter:Add("effects/splash1", self.Position - vecang*32*self.Scale - self.Normal*16)
			local dietime = math.Rand(20.5,20.9)*self.Scale
			particle:SetVelocity(velocity*self.Scale)
			particle:SetGravity(Vector(0,0,math.Rand(0,0)))
			particle:SetAirResistance(50)
			particle:SetDieTime(dietime)
			particle:SetStartAlpha(200)
			particle:SetEndAlpha( 0 )
			particle:SetStartSize(math.Rand(500,500)*self.ScaleSlow)
			particle:SetEndSize(math.Rand(800,800)*self.ScaleSlow)
			particle:SetRoll(math.Rand(150,180))
			particle:SetRollDelta(0.6*math.random(-1,1))
			particle:SetColor(255,255,255)
			
		end



		--Mushroom CloudSmoke
		for i=1,math.ceil(self.Scale*60) do

			local vecang = self.RightAngle
                  local startalpha = math.Rand( 0, 0 )
			vecang:RotateAroundAxis(self.Normal,math.Rand(0,360))
			vecang = vecang:Forward() + VectorRand()*0.1
			local velocity = math.Rand(100,10000)*vecang
			local particle = emitter:Add("modulus/particles/Smoke6",self.Position - vecang*32*self.Scale - self.Normal*16)
			local dietime = math.Rand(25.5,25.9)*self.Scale
			particle:SetVelocity(velocity*self.Scale)
			particle:SetGravity(Vector(0,0,math.Rand(1000,1000)))
			particle:SetAirResistance(200)
                 	particle:SetThinkFunction(SmokeParticleUpdate)
			particle:SetNextThink(CurrentTime + 0.5*dietime)
			particle:SetDieTime(dietime)
			particle:SetStartAlpha(startaplha)
			particle:SetEndAlpha( 250 + startalpha )
			particle:SetStartSize(math.Rand(800,2000)*self.ScaleSlow)
			particle:SetEndSize(math.Rand(800,2000)*self.ScaleSlow)
			particle:SetRoll(math.Rand(150,180))
			particle:SetRollDelta(0.6*math.random(-1,1))
			particle:SetColor(50,50,50)
			table.insert(self.smokeparticles,particle)
                  
		end
		--Mushroom CloudSmoke
		for i=1,math.ceil(self.Scale*60) do

			local vecang = self.RightAngle
                  local startalpha = math.Rand( 0, 0 )
			vecang:RotateAroundAxis(self.Normal,math.Rand(0,360))
			vecang = vecang:Forward() + VectorRand()*0.1
			local velocity = math.Rand(100,6000)*vecang
			local particle = emitter:Add("modulus/particles/Smoke6",self.Position - vecang*32*self.Scale - self.Normal*16)
			local dietime = math.Rand(25.5,25.9)*self.Scale
			particle:SetVelocity(velocity*self.Scale)
			particle:SetGravity(Vector(0,0,math.Rand(0,0)))
			particle:SetAirResistance(200)
                 	particle:SetThinkFunction(SmokeParticleUpdate)
			particle:SetNextThink(CurrentTime + 0.5*dietime)
			particle:SetDieTime(dietime)
			particle:SetStartAlpha(startaplha)
			particle:SetEndAlpha( 250 + startalpha )
			particle:SetStartSize(math.Rand(500,1000)*self.ScaleSlow)
			particle:SetEndSize(math.Rand(500,1000)*self.ScaleSlow)
			particle:SetRoll(math.Rand(150,180))
			particle:SetRollDelta(0.6*math.random(-1,1))
			particle:SetColor(50,50,50)
                  table.insert(self.smokeparticles,particle)
                  
			end

	emitter:Finish()
	
		surface.PlaySound("ambient/explosions/explode_8.wav")
		self.Entity:EmitSound("ambient/explosions/explode_4.wav")

end

--THINK
-- Returning false makes the entity die
function EFFECT:Think()
	local TimeLeft = self.KillTime - CurTime()
	local TimeScale = TimeLeft/self.Duration
	local FTime = FrameTime()
	if TimeLeft > 0 then 



		self.FlashAlpha = self.FlashAlpha - 100*FTime
		self.FlashSize = self.FlashSize + 12000*FTime
		
		self.GlowAlpha = 200*TimeScale
		self.GlowSize = 200

	self.Refract = self.Refract + 2.0 * FrameTime()
	self.Size = 512 * self.Refract^(0.2)
	
	if ( self.Refract >= 10 ) then return false 
      

      end
	
            
		return true
	else
		for __,particle in pairs(self.smokeparticles) do
		particle:SetStartAlpha( 100 )
		particle:SetEndAlpha( 0 )
		end
		return false	
	end





end





-- Draw the effect
function EFFECT:Render()

--base glow
render.SetMaterial(tMats.Glow1)
render.DrawSprite(self.Position2,7000*self.GlowSize,5500*self.GlowSize,Color(255,240,220,self.GlowAlpha))

--blinding flash

if self.Size > 0 then
		render.SetMaterial(tMats.Glow2)
		render.DrawSprite(self.Position2,self.FlashSize,self.FlashSize,Color(255,245,215,self.FlashAlpha))
	end
--shockwave

	local Distance = EyePos():Distance( self.Entity:GetPos() )
	local Pos = self.Entity:GetPos() + (EyePos()-self.Entity:GetPos()):GetNormal() * Distance * (self.Refract^(0.3)) * 0.8

	matRefraction:SetMaterialFloat( "$refractamount", math.sin( self.Refract * math.pi ) * 0.1 )
	render.SetMaterial( matRefraction )
	render.UpdateRefractTexture()
	render.DrawSprite( Pos, self.Size, self.Size )

end








