


local tMats = {}
tMats.Glow1 = Material("sprites/flare1")
tMats.Glow2 = Material("sprites/flare1")
tMats.Glow3 = Material("sprites/redglow2")
for _,mat in pairs(tMats) do

	mat:SetMaterialInt("$spriterendermode",9)
	mat:SetMaterialInt("$ignorez",1)
	mat:SetMaterialInt("$illumfactor",8)
	
end

local SmokeParticleUpdate = function(particle)

	if particle:GetStartAlpha() == 0 and particle:GetLifeTime() >= 0.5*particle:GetDieTime() then
		particle:SetStartAlpha(particle:GetEndAlpha())
		particle:SetEndAlpha(0)
		particle:SetNextThink(-1)
	else
		particle:SetNextThink(CurTime() + 0.1)
	end

	return particle

end



function EFFECT:Init(data)

	self.Scale = data:GetScale()
	self.ScaleSlow = math.sqrt(self.Scale)
	self.ScaleSlowest = math.sqrt(self.ScaleSlow)
	self.Normal = data:GetNormal()
	self.RightAngle = self.Normal:Angle():Right():Angle()
	self.Position = data:GetOrigin() - 12*self.Normal
	self.Position2 = self.Position + self.Scale*64*self.Normal

	local CurrentTime = CurTime()
	self.Duration = 0.5
	self.KillTime = CurrentTime + self.Duration
	self.GlowAlpha = 0
	self.GlowSize = 500*self.Scale
	self.FlashAlpha = 0
	self.FlashSize = 500


	local emitter = ParticleEmitter(self.Position)

			self.smokeparticles = {}






	--pillar of dust
		for i=1,math.ceil(self.Scale*30) do

			local vecang = (self.Normal + VectorRand()*math.Rand(0,0.5)):GetNormalized()
			local velocity = math.Rand(-700,700)*vecang*self.Scale
			local particle = emitter:Add("particles/Smoke4",self.Position + vecang*math.Rand(-50,90)*self.Scale)
			local dietime = math.Rand(7.8,7.4)*self.Scale
			particle:SetVelocity(velocity)       
                 	particle:SetThinkFunction(SmokeParticleUpdate)
			particle:SetNextThink(CurrentTime + 0.5*dietime)
			particle:SetGravity(Vector(0,0,math.Rand(0,1800)))
			particle:SetAirResistance(200)
			particle:SetDieTime(dietime)
			particle:SetStartAlpha(150)
			particle:SetEndAlpha(0)
			particle:SetStartSize(math.Rand(400,400)*self.ScaleSlow)
			particle:SetEndSize(math.Rand(700,700)*self.ScaleSlow)
			particle:SetRoll(math.Rand(150,170))
			particle:SetRollDelta(0.7*math.random(-1,1))
			particle:SetColor(50,50,50)
			
		end
		--Mushroom Cloud
		for i=1,math.ceil(self.Scale*30) do

			local vecang = self.RightAngle
                  local startalpha = math.Rand( 0, 0 )
			vecang:RotateAroundAxis(self.Normal,math.Rand(0,360))
			vecang = vecang:Forward() + VectorRand()*0.1
			local velocity = math.Rand(100,2000)*vecang
			local particle = emitter:Add("particles/Smoke4",self.Position - vecang*32*self.Scale - self.Normal*16)
			local dietime = math.Rand(7.5,7.9)*self.Scale
			particle:SetVelocity(velocity*self.Scale)
			particle:SetGravity(Vector(0,0,math.Rand(0,0)))
			particle:SetAirResistance(50)
                 	particle:SetThinkFunction(SmokeParticleUpdate)
			particle:SetNextThink(CurrentTime + 0.5*dietime)
			particle:SetDieTime(dietime)
			particle:SetStartAlpha(150)
			particle:SetEndAlpha( 0 )
			particle:SetStartSize(math.Rand(500,500)*self.ScaleSlow)
			particle:SetEndSize(math.Rand(800,800)*self.ScaleSlow)
			particle:SetRoll(math.Rand(150,180))
			particle:SetRollDelta(0.6*math.random(-1,1))
			particle:SetColor(200,200,200)
			
		end
		--Mushroom Cloud
		for i=1,math.ceil(self.Scale*30) do

			local vecang = self.RightAngle
                  local startalpha = math.Rand( 0, 0 )
			vecang:RotateAroundAxis(self.Normal,math.Rand(0,360))
			vecang = vecang:Forward() + VectorRand()*0.1
			local velocity = math.Rand(100,8000)*vecang
			local particle = emitter:Add("particles/Fire7",self.Position - vecang*32*self.Scale - self.Normal*16)
			local dietime = math.Rand(7.5,7.9)*self.Scale
			particle:SetVelocity(velocity*self.Scale)
			particle:SetGravity(Vector(0,0,math.Rand(1800,1800)))
			particle:SetAirResistance(200)
                 	particle:SetThinkFunction(SmokeParticleUpdate)
			particle:SetNextThink(CurrentTime + 0.5*dietime)
			particle:SetDieTime(dietime)
			particle:SetStartAlpha(150)
			particle:SetEndAlpha( 0 )
			particle:SetStartSize(math.Rand(800,800)*self.ScaleSlow)
			particle:SetEndSize(math.Rand(1000,1000)*self.ScaleSlow)
			particle:SetRoll(math.Rand(150,180))
			particle:SetRollDelta(0.6*math.random(-1,1))
			particle:SetColor(200,200,200)
			
		end
			emitter:Finish()
	
		surface.PlaySound("ambient/explosions/explode_8.wav")
		self.Entity:EmitSound("ambient/explosions/explode_4.wav")

end

--THINK
-- Returning false makes the entity die
function EFFECT:Think()
	local TimeLeft = self.KillTime - CurTime()
	local TimeScale = TimeLeft/self.Duration
	local FTime = FrameTime()
	if TimeLeft > 0 then 



		self.FlashAlpha = self.FlashAlpha - 250
		self.FlashSize = 500
		
		self.GlowAlpha = 200*TimeScale
		self.GlowSize = 500


            
		return true
	else
		for __,particle in pairs(self.smokeparticles) do
		particle:SetStartAlpha( 200 )
		particle:SetEndAlpha( 0 )
		end
		return false	
	end





end






-- Draw the effect
function EFFECT:Render()

--base glow
render.SetMaterial(tMats.Glow1)
render.DrawSprite(self.Position2,7000*self.GlowSize,5500*self.GlowSize,Color(255,240,220,self.GlowAlpha))

--blinding flash
	if self.FlashAlpha > 0 then
		render.SetMaterial(tMats.Glow2)
		render.DrawSprite(self.Position2,self.FlashSize,self.FlashSize,Color(255,245,215,self.FlashAlpha))
end
end








